=== debian/changelog ===
libcap2 (1:2.66-5ubuntu2.2trisquel1) ecne-security; urgency=medium

  * Fetch and build as udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Mon, 24 Feb 2025 17:44:47 +0000

libcap2 (1:2.66-5ubuntu2.2) noble-security; urgency=medium

  * SECURITY UPDATE: incorrect group name handling
    - debian/patches/CVE-2025-1390-1.patch: fix potential configuration
      parsing error in pam_cap/pam_cap.c.
    - debian/patches/CVE-2025-1390-2.patch: add a test for bad group prefix
      in pam_cap/sudotest.conf.
    - CVE-2025-1390

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 20 Feb 2025 10:49:57 -0500
