=== debian/changelog ===
libcap2 (1:2.73-4ubuntu1) plucky; urgency=medium

  * Merge with Debian Unstable. Remaining changes:
    - Strip -Wl,-Bsymbolic-functions from LDFLAGS (LP: #2003892)
    - d/t/upstream-root: Skip "uns_test" to fix autopkgtests on armhf.
      It's failing on armhf due to the version of the kernel we use in our
      infrastructure for for this architecture. Once we upgrade our hosts,
      this patch can be dropped. See LP: #2003892.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Thu, 20 Feb 2025 14:00:25 -0600

libcap2 (1:2.73-4) unstable; urgency=medium

  * Cherry-pick patch fixing CVE-2025-1390.
    In /etc/security/capability.conf, configurations not starting with "@"
    were incorrectly recognized as group names. (Closes: #1098318)
  * Fix bug number in previous changelog entry

 -- Christian Kastner <ckk@debian.org>  Wed, 19 Feb 2025 23:17:43 +0100

libcap2 (1:2.73-3) unstable; urgency=medium

  [ Christian Kastner ]
  * libcap2-bin.install: Skip pam_cap.8
    As upstream also ships this file now, installing all of man8 also
    installed pam_cap.8, whereas we were shipping our own version in
    libpam-cap. Our own version was dropped, and libpam-cap will ship
    upstream's version instead. (Closes: #1096207, #1098209)
  * Bump Standards-Version to 4.7.0 (no changes needed)

  [ Otto Kekäläinen ]
  * Enable Salsa CI using default template.
    Keep BLHC disabled so that the pipeline can pass. The purpose it so catch
    regressions, so the pipeline should be green on mainline.

 -- Christian Kastner <ckk@debian.org>  Mon, 17 Feb 2025 21:52:02 +0100

libcap2 (1:2.73-2) unstable; urgency=medium

  * symbols: Drop accidentally included Debian revision

 -- Christian Kastner <ckk@debian.org>  Mon, 17 Feb 2025 11:02:53 +0100

libcap2 (1:2.73-1) unstable; urgency=medium

  * New upstream version 2.73
    - Refresh patches
  * Use capability.conf.5 now provided by upstream
  * Update symbols file
    This drops internal symbols but also one symbol that was exported, but
    clearly not intended to be.
  * d/rules: Undo file change in clean step.
    Resolves a FTBFS twice in a row.

 -- Christian Kastner <ckk@debian.org>  Mon, 17 Feb 2025 10:46:10 +0100
