=== contrib/Makefile ===
.PHONY: all clean
all clean:
	for x in bug* ; do $(MAKE) -C $$x $@ || exit 1 ; done
