=== debian/changelog ===
libcap2 (1:2.75-7ubuntu2) questing; urgency=medium

  * Rebuild to include updated RISC-V base ISA RVA23

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Fri, 05 Sep 2025 15:29:30 +0000

libcap2 (1:2.75-7ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #2111776). Remaining changes:
    - Strip -Wl,-Bsymbolic-functions from LDFLAGS (LP: #2003892)
  * Dropped Changes:
    - d/t/upstream-root: Skip "uns_test" to fix autopkgtests on armhf.
      It's failing on armhf due to the version of the kernel we use in our
      infrastructure for for this architecture. Once we upgrade our hosts,
      this patch can be dropped. See LP: #2003892.

 -- Pragyansh Chaturvedi <pragyansh.chaturvedi@canonical.com>  Tue, 27 May 2025 12:56:51 +0530

libcap2 (1:2.75-7) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Move go dependencies to B-D-I. (Closes: #1103808)

 -- Christian Kastner <ckk@debian.org>  Mon, 21 Apr 2025 20:42:52 +0200

libcap2 (1:2.75-6) unstable; urgency=medium

  * Add cleaning for Golang build
  * Switch from chrpath to patchelf

 -- Christian Kastner <ckk@debian.org>  Fri, 11 Apr 2025 20:52:04 +0200

libcap2 (1:2.75-5) unstable; urgency=medium

  * Upload to unstable
  * Cherry-pick a signal handler API fix

 -- Christian Kastner <ckk@debian.org>  Wed, 09 Apr 2025 23:38:14 +0200

libcap2 (1:2.75-5~exp1) experimental; urgency=medium

  [ Simon Josefsson ]
  * Add Go package.

 -- Christian Kastner <ckk@debian.org>  Mon, 07 Apr 2025 13:14:39 +0200

libcap2 (1:2.75-4) unstable; urgency=medium

  * Upload to unstable.

 -- Christian Kastner <ckk@debian.org>  Tue, 25 Mar 2025 21:24:16 +0100

libcap2 (1:2.75-4~exp1) experimental; urgency=medium

  * Cherry-pick upstream patches attempting FTBFS fix on debian-ports
   - Add new symbol to symbols file
  * Re-enable executable library tests

 -- Christian Kastner <ckk@debian.org>  Sun, 23 Mar 2025 19:30:49 +0100

libcap2 (1:2.75-3) unstable; urgency=medium

  * Temporarily skip tests on mips64el, powerpc.
    Affected by #1089636 in glibc.

 -- Christian Kastner <ckk@debian.org>  Thu, 20 Mar 2025 23:46:07 +0100

libcap2 (1:2.75-2) unstable; urgency=medium

  * Skip executable shared library test.
    This segfaults on mips64el and powerpc. Since this functionality is not
    enabled anyway, skip the test for now until the root cause has been
    identified and resolved. (Closes: #1089636)

 -- Christian Kastner <ckk@debian.org>  Thu, 13 Mar 2025 15:36:17 +0100

libcap2 (1:2.75-1) unstable; urgency=medium

  [ Otto Kekäläinen ]
  * Salsa CI: Test for missing Breaks and Replaces.

  [ Christian Kastner ]
  * New upstream version 2.75
  * Refresh patches
  * gbp.conf Add upstream-signatures=on

 -- Christian Kastner <ckk@debian.org>  Fri, 07 Mar 2025 10:05:09 +0100
