=== debian/rules ===
--- 
+++ 
@@ -38,6 +38,12 @@
 
 override_dh_auto_clean:
 	dh_auto_clean -- $(MAKE_ASSIGNMENTS)
+	# The Golang build system does not appear to fully honor -B, so we need
+	# two cleans
+	set -e; if test -d _build; then \
+		dh_auto_clean -B_build -O--buildsystem=golang; \
+		dh_auto_clean O--buildsystem=golang; \
+	fi
 	# Undo change of lookup (see override_dh_auto_build)
 	sed -i -e 's,\./tcapsh-static,../progs/tcapsh-static,g' tests/libcap_launch_test.c
 
@@ -81,7 +87,7 @@
 	# (avoiding it and going through LD_LIBRARY_PATH didn't work in all
 	# cases)
 	# List is identical to build above, minus noop (no RPATH)
-	cd tests && chrpath -d \
+	cd tests && patchelf --remove-rpath \
 		psx_test \
 		libcap_psx_test \
 		uns_test \
@@ -104,3 +110,16 @@
 	dh_makeshlibs -V'libcap2 (>= $(SHLIBS_MINVER))' -plibcap2 \
 		--add-udeb=libcap2-udeb -- -c4
 	dh_makeshlibs --remaining-packages -- -c4
+
+export DH_GOLANG_BUILDPKG := \
+	kernel.org/pub/linux/libs/security/libcap/cap \
+	kernel.org/pub/linux/libs/security/libcap/psx
+
+execute_after_dh_auto_configure-indep:
+	dh_auto_configure -B_build -O--buildsystem=golang
+
+execute_after_dh_auto_install-indep:
+	dh_auto_install -B_build -O--buildsystem=golang
+
+execute_after_dh_auto_build-indep:
+	dh_auto_build -B_build -O--buildsystem=golang
