=== debian/watch ===
version=4

opts="pgpsigurlmangle=s%\.xz$%.sign%,decompress" \
https://www.kernel.org/pub/linux/libs/security/linux-privs/libcap2/libcap-(.+).tar.xz
